// wince-dlg.c

#include <windows.h>
#include <windowsx.h>
#include "celib.h"
#include "resource.h"

LRESULT PasswordProc(HWND, UINT, WPARAM, LPARAM);

static char g_prompt[126];
static char g_password[126];

LRESULT 
PasswordProc(HWND hdlg, UINT uMessage, WPARAM wparam, LPARAM lparam)
{
  switch(uMessage)
    {
    case WM_INITDIALOG:
      SetDlgItemText(hdlg, IDC_PROMPT, g_prompt);
      return 1;
      break;
    case WM_COMMAND:
      switch(GET_WM_COMMAND_ID(wparam, lparam))
	{
	case IDOK:
	  GetDlgItemText(hdlg, IDC_PASS, g_password, sizeof(g_password));
	  EndDialog(hdlg, IDOK);
	  return 1;
	case IDCANCEL:
	  EndDialog(hdlg, IDCANCEL);
	  return 1;
	default:
	  return 0;
	}
      break;
    default:
      break;
    }
  return 0;
}

extern HINSTANCE hInst; 
extern HWND hMainWnd;

int
WCEGetPass(char *prompt, char *password)
{
  int nres;
  HWND hwnd = NULL;

  hwnd = hMainWnd;

  strcpy(g_prompt, prompt);
  g_password[0] = 0;

  ShowWindow(hMainWnd, SW_SHOW);
  if((nres = DialogBoxParamW(hInst, MAKEINTRESOURCE(IDD_PASSWORD), hwnd, 
			     (DLGPROC) PasswordProc, 0)) == -1)
    {
      XCEShowMessageA("GetPass: Error %d", GetLastError());
      return -1;
    }

  if(nres == IDOK)
    {
      strcpy(password, g_password);
      return 0;
    }
  return -1;
}
